<?php

header('Content-Type: text/html; charset=UTF-8');
header('Cache-Control: private');

ini_set("session.use_trans_sid","0");
ini_set("mbstring.language","Neutral");
ini_set("mbstring.internal_encoding","UTF-8");
ini_set("mbstring.encoding_translation","On");
ini_set("mbstring.http_input","auto");
ini_set("mbstring.http_output","UTF-8");
ini_set("mbstring.detect_order","auto");
ini_set("mbstring.substitute_character","none");
ini_set("default_charset","UTF-8");

error_reporting(E_ERROR);

session_start();

$maj_data_directory = "data";
$maj_image_directory = "images";

$maj_default_title = file_get_contents("$maj_data_directory/title.txt");
$maj_admin_username = file_get_contents("$maj_data_directory/username.txt");

if (isset($_SESSION['logged_in'])) {
	$maj_logged_in_username = $_SESSION['logged_in'];
}

if (isset($maj_logged_in_username) and ($_SESSION['user_agent'] != $_SERVER['HTTP_USER_AGENT'])) {
	header("Location: login.php");
}

if (get_magic_quotes_gpc()) {

	function stripslashes_array($data) {
          
		if (is_array($data)) {
              
			foreach ($data as $key => $value) {
                  		$data[$key] = stripslashes_array($value);
              		}
              		return $data;
          	}
          	else {
              		return stripslashes($data);
          	}
      	}
      	$_REQUEST = stripslashes_array($_REQUEST);
}

if (isset($_REQUEST['entry']) and !empty($_REQUEST['entry'])) {
	$maj_req_entry = trim($_REQUEST['entry']);
}

if (isset($_REQUEST['show']) and !empty($_REQUEST['show'])) {
	$maj_req_show = trim($_REQUEST['show']);
}

if (isset($_REQUEST['find']) and !empty($_REQUEST['find'])) {
	$maj_req_find = trim($_REQUEST['find']);
	$maj_req_find = str_replace(" ","-",$maj_req_find);
	$maj_req_find = mb_strtolower($maj_req_find);
	$maj_req_find = strip_tags($maj_req_find);
}

if (isset($_REQUEST['category']) and !empty($_REQUEST['category'])) {
	$maj_req_category = trim($_REQUEST['category']);
	$maj_req_category = str_replace(" ","-",$maj_req_category);
	$maj_req_category = mb_strtolower($maj_req_category);
	$maj_req_category = strip_tags($maj_req_category);
}

if (isset($_REQUEST['archive']) and !empty($_REQUEST['archive'])) {
	$maj_req_archive = trim($_REQUEST['archive']);
}

if (isset($_REQUEST['author']) and !empty($_REQUEST['author'])) {
	$maj_req_author = trim($_REQUEST['author']);
	$maj_req_author = str_replace(" ","-",$maj_req_author);
	$maj_req_author = mb_strtolower($maj_req_author);
	$maj_req_author = strip_tags($maj_req_author);
}

if (file_exists("$maj_data_directory/offset.txt")) {
	$maj_offset = file_get_contents("$maj_data_directory/offset.txt");
}
else {
	$maj_offset = 0;
}

if (file_exists("$maj_data_directory/increase.txt")) {
	$maj_increase = file_get_contents("$maj_data_directory/increase.txt");
}
else {
	$maj_increase = 5;
}

if (file_exists("$maj_data_directory/bb.txt") and file_exists("$maj_data_directory/avatar.txt")) {
	$maj_wside = "160";
	$maj_wmain = "600";
}
else {
	$maj_wside = "200";
	$maj_wmain = "520";
}

$maj_wspace = "10";

$maj_wtable = $maj_wspace + $maj_wside + $maj_wspace + $maj_wmain + $maj_wspace + $maj_wside + $maj_wspace;

$maj_default_blog_title = "My Activity Journal";
$maj_default_username = "maj";
$maj_default_password = "php";
$maj_default_blog_profile = 'This cool site is powered by My Activity Journal (<a href="http://majcms.org/" target="_maj">MAJ</a>), a simple <a href="http://php.net/" target="_maj">PHP</a>-based, <a href="http://opensource.org/" target="_maj">Open Source</a> content management system (CMS) that can be deployed as a blog, bulletin board (Internet forum or message board), and wiki.';
$maj_default_blog_author = "My Activity Journal";

if (!file_exists($maj_data_directory)) {
	mkdir($maj_data_directory);
}

if (!file_exists("$maj_data_directory/.htaccess")) {
	$maj_htaccess = "Order deny,allow\nDeny from all";
	$maj_fp_htaccess_txt = fopen("$maj_data_directory/.htaccess","w");
	fwrite($maj_fp_htaccess_txt,$maj_htaccess);
	fclose($maj_fp_htaccess_txt);
}

if (!file_exists("$maj_data_directory/title.txt")) {
	$maj_fp_default_title_txt = fopen("$maj_data_directory/title.txt","w");
	fwrite($maj_fp_default_title_txt,$maj_default_blog_title);
	fclose($maj_fp_default_title_txt);
}

if (!file_exists("$maj_data_directory/username.txt")) {
	$maj_fp_htaccess_txt = fopen("$maj_data_directory/username.txt","w");
	fwrite($maj_fp_htaccess_txt,$maj_default_username);
	fclose($maj_fp_htaccess_txt);
}

if (!file_exists("$maj_data_directory/password.txt")) {
	$maj_default_password = sha1($maj_default_password);
	$maj_default_password = md5($maj_default_password);
	$maj_default_password = crypt($maj_default_password,$maj_default_password);
	$maj_fp_htaccess_txt = fopen("$maj_data_directory/password.txt","w");
	fwrite($maj_fp_htaccess_txt,$maj_default_password);
	fclose($maj_fp_htaccess_txt);
}

if (!file_exists("$maj_data_directory/profile.php")) {
	$maj_fp_default_profile_txt = fopen("$maj_data_directory/profile.php","w");
	fwrite($maj_fp_default_profile_txt,$maj_default_blog_profile);
	fclose($maj_fp_default_profile_txt);
}

if (!file_exists("$maj_data_directory/author.txt")) {
	$maj_fp_default_author_txt = fopen("$maj_data_directory/author.txt","w");
	fwrite($maj_fp_default_author_txt,$maj_default_blog_author);
	fclose($maj_fp_default_author_txt);
}

function str_rand($length = 8,$seeds = 'abcdefghijklmnopqrstuvwxyz0123456789') {

	$str = '';
	$count = mb_strlen($seeds);
 
	list($usec,$sec) = explode(' ',microtime());

	$seed = (float) $sec + ((float) $usec * 100000);

	mt_srand($seed);
 
	for ($i = 0; $length > $i; $i++) {
		$str .= $seeds{mt_rand(0,$count - 1)};
	}
	return $str;
}

function rmdirr($dir) {
      
	if (!file_exists($dir)) {
          	return false;
      	}
      
      	if (is_file($dir)) {
          	return unlink($dir);
      	}
      
      	$recurse = dir($dir);
      
      	while (false !== $entry = $recurse->read()) {
          
		if ($entry == '.' || $entry == '..') {
              		continue;
          	}
          
          	rmdirr("$dir/$entry");
      	}
      
      	$recurse->close();
      	return rmdir($dir);
}
  
function return_bytes($val) {
      
	$val = trim($val);
      	$last = $val{mb_strlen($val) - 1};
      
      	switch ($last) {
          	case 'k':
          	case 'K':
              		return(int)$val * 1024;
              		break;
          	case 'm':
          	case 'M':
              		return(int)$val * 1048576;
              		break;
          	default:
              		return $val;
      	}
}

$server_upload_max_filesize = return_bytes(ini_get('upload_max_filesize'));
$server_post_max_size = return_bytes(ini_get('post_max_size'));
$server_memory_limit = return_bytes(ini_get('memory_limit'));
  
$max_file_size = $server_upload_max_filesize;
  
if ($server_upload_max_filesize > $server_post_max_size) {
	$max_file_size = $server_post_max_size;
}
  
if ($server_post_max_size > $server_memory_limit) {
	$max_file_size = $server_memory_limit;
}
  
function entry2date($entry) {

      	$year = mb_substr($entry, 0, 4);
      	$month = mb_substr($entry, 4, 2);
      	$day = mb_substr($entry, 6, 2);
      	$hour = mb_substr($entry, 8, 2);
      	$min = mb_substr($entry, 10, 2);
      	$sec = mb_substr($entry, 12, 2);
      
      	echo date("l, M j, Y, g:i A", mktime($hour, $min, $sec, $month, $day, $year));
}

function reformat_html($data) {

      	$store_0 = mb_split("<html>", $data);
      	$data = "";
      	$data .= $store_0[0];
      
      	foreach ($store_0 as $item_0 => $ref_0) {
          
		if (mb_eregi("</html>", $ref_0)) {
              
			$store_1 = mb_split("</html>", $ref_0);
              		$store_1[0] = mb_eregi_replace("\n", "", $store_1[0]);
              
              		foreach ($store_1 as $item_1 => $ref_1) {
                  
				if ($item_1 == 0) {
					$ref_1 = "<!-- html -->$ref_1<!-- /html -->";
				}
                  		$data .= $ref_1;
              		}
          	}
      	}
      	return $data;
}

function reformat_code($data) {

	global $maj_image_directory;

      	$store_0 = mb_split("<code>", $data);
      	$data = "";
      	$data .= $store_0[0];
      
      	foreach ($store_0 as $item_0 => $ref_0) {
          
		if (mb_eregi("</code>", $ref_0)) {

              		$store_1 = mb_split("</code>", $ref_0);
              		$store_1[0] = mb_eregi_replace("<img src=\"$maj_image_directory/smileys/crying.png\" border=\"0\">", ':((', $store_1[0]);
              		$store_1[0] = mb_eregi_replace("<img src=\"$maj_image_directory/smileys/frown.png\" border=\"0\">", ':(', $store_1[0]);
              		$store_1[0] = mb_eregi_replace("<img src=\"$maj_image_directory/smileys/indifferent.png\" border=\"0\">", ':|', $store_1[0]);
              		$store_1[0] = mb_eregi_replace("<img src=\"$maj_image_directory/smileys/laughing.png\" border=\"0\">", ':D', $store_1[0]);
              		$store_1[0] = mb_eregi_replace("<img src=\"$maj_image_directory/smileys/lick.png\" border=\"0\">", ':P', $store_1[0]);
              		$store_1[0] = mb_eregi_replace("<img src=\"$maj_image_directory/smileys/ohno.png\" border=\"0\">", ':O', $store_1[0]);
              		$store_1[0] = mb_eregi_replace("<img src=\"$maj_image_directory/smileys/smile.png\" border=\"0\">", ':)', $store_1[0]);
              		$store_1[0] = mb_eregi_replace("<img src=\"$maj_image_directory/smileys/surprised.png\" border=\"0\">", '=)', $store_1[0]);
              		$store_1[0] = mb_eregi_replace("<img src=\"$maj_image_directory/smileys/undecided.png\" border=\"0\">", ':\\', $store_1[0]);
              		$store_1[0] = mb_eregi_replace("<img src=\"$maj_image_directory/smileys/wink.png\" border=\"0\">", ';)', $store_1[0]);
              		$store_1[0] = htmlentities($store_1[0], ENT_QUOTES, 'UTF-8');
              
              		foreach ($store_1 as $item_1 => $ref_1) {

                  		if ($item_1 == 0) {
                      			$ref_1 = "<code>$ref_1</code>";
				}
                  		$data .= $ref_1;
              		}
          	}
	}
      	return $data;
}
  
function format_title_put($data) {
      
	// 20100113 - auto-captialize title except articles, prepositions and conjunctions less tha 4 letters, and particle "to"
      	$data = ucwords($data);
      	$data = str_replace('<', '&lt;', $data);
      	$data = str_replace('>', '&gt;', $data);
      	$data = str_replace(' A ', ' a ', $data);
      	$data = str_replace(' An ', ' an ', $data);
      	$data = str_replace(' And ', ' and ', $data);
      	$data = str_replace(' As ', ' as ', $data);
      	$data = str_replace(' At ', ' at ', $data);
      	$data = str_replace(' But ', ' but ', $data);
      	$data = str_replace(' By ', ' by ', $data);
      	$data = str_replace(' For ', ' for ', $data);
      	$data = str_replace(' In ', ' in ', $data);
      	$data = str_replace(' Of ', ' of ', $data);
      	$data = str_replace(' On ', ' on ', $data);
      	$data = str_replace(' Or ', ' or ', $data);
      	$data = str_replace(' The ', ' the ', $data);
      	$data = str_replace(' To ', ' to ', $data);
      
      	return $data;
} 
  
function format_body_put($data) {

	global $maj_image_directory;
      
	$data = ucfirst($data);
      	$data = str_replace("[html]", '<html>', $data);
      	$data = str_replace("[/html]", '</html>', $data);
      	$data = reformat_html($data);
      	$data = str_replace(':((', "<img src=\"$maj_image_directory/smileys/crying.png\" border=\"0\">", $data);
      	$data = str_replace(':(', "<img src=\"$maj_image_directory/smileys/frown.png\" border=\"0\">", $data);
      	$data = str_replace(':|', "<img src=\"$maj_image_directory/smileys/indifferent.png\" border=\"0\">", $data);
      	$data = str_replace(':D', "<img src=\"$maj_image_directory/smileys/laughing.png\" border=\"0\">", $data);
      	$data = str_replace(':P', "<img src=\"$maj_image_directory/smileys/lick.png\" border=\"0\">", $data);
      	$data = str_replace(':O', "<img src=\"$maj_image_directory/smileys/ohno.png\" border=\"0\">", $data);
      	$data = str_replace(':)', "<img src=\"$maj_image_directory/smileys/smile.png\" border=\"0\">", $data);
      	$data = str_replace('=)', "<img src=\"$maj_image_directory/smileys/surprised.png\" border=\"0\">", $data);
      	$data = str_replace(':\\', "<img src=\"$maj_image_directory/smileys/undecided.png\" border=\"0\">", $data);
      	$data = str_replace(';)', "<img src=\"$maj_image_directory/smileys/wink.png\" border=\"0\">", $data);
      	$data = str_replace('[code]', '<code>', $data);
      	$data = str_replace('[/code]', '</code>', $data);
      	$data = reformat_code($data);
      	$data = str_replace("\n", '<br />', $data);
      	$data = str_replace('[b]', '<b>', $data);
      	$data = str_replace('[/b]', '</b>', $data);
      	$data = str_replace('[i]', '<i>', $data);
      	$data = str_replace('[/i]', '</i>', $data);
      	$data = str_replace('[u]', '<u>', $data);
      	$data = str_replace('[/u]', '</u>', $data);
      	$data = str_replace('[strike]', '<strike>', $data);
      	$data = str_replace('[/strike]', '</strike>', $data);
      	$data = str_replace('[sup]', '<sup>', $data);
      	$data = str_replace('[/sup]', '</sup>', $data);
      	$data = str_replace('[sub]', '<sub>', $data);
      	$data = str_replace('[/sub]', '</sub>', $data);
      	$data = str_replace('[highlight]', '<highlight>', $data);
      	$data = str_replace('[/highlight]', '</highlight>', $data);
      	$data = str_replace('<highlight>', '<span style="background-color: #ffff00;">', $data);
      	$data = str_replace('</highlight>', '</span>', $data);
      	$data = preg_replace("/<([_\.0-9a-z-]+)@([0-9a-z][0-9a-z-]+)\.([_\.0-9a-z-]+)>/", '&lt;$1@$2.$3&gt;', $data);
      
      	return $data;
}

function maj_avatar_image($author_username,$max_img_width=80,$show_username=1,$show_rank=1) {

	global $maj_admin_username;
	global $maj_data_directory;
	global $maj_image_directory;

	echo "<a href=\"member.php?id=$author_username\">";

	if (($maj_admin_username == $author_username) and (file_exists("$maj_image_directory/avatar.jpg") or file_exists("$maj_image_directory/avatar.gif") or file_exists("$maj_image_directory/avatar.png"))) {

		if (file_exists("$maj_image_directory/avatar.gif")) {

			$avatar_gif_image_size = getimagesize("$maj_image_directory/avatar.gif");
			$avatar_gif_image_width = $avatar_gif_image_size[0];
			$avatar_gif_image_height = $avatar_gif_image_size[1];

			if ($avatar_gif_image_width > $max_img_width) {   

				$sizefactor = (double) ($max_img_width / $avatar_gif_image_width) ;
				$avatar_gif_image_width = (int) ($avatar_gif_image_width * $sizefactor);
				$avatar_gif_image_height = (int) ($avatar_gif_image_height * $sizefactor); 

				if (file_exists("$maj_data_directory/avatar-resize-gif.txt")) {

					$avatar_gif_image_resize = imagecreatetruecolor($avatar_gif_image_width,$avatar_gif_image_height);

					imagealphablending($avatar_gif_image_resize, false);
					imagesavealpha($avatar_gif_image_resize, true);

					$avatar_gif_image_original = imagecreatefromgif("$maj_image_directory/avatar.gif");
					$avatar_gif_transparent_index = imagecolortransparent($avatar_gif_image_original);

					if ($avatar_gif_transparent_index >= 0) {

						$avatar_gif_transparent_color = imagecolorsforindex($avatar_gif_image_original, $avatar_gif_transparent_index);
						$avatar_gif_transparent_index = imagecolorallocate($avatar_gif_image_resize, $avatar_gif_transparent_color['red'], $avatar_gif_transparent_color['green'], $avatar_gif_transparent_color['blue']);

						imagefill($avatar_gif_image_resize, 0, 0, $avatar_gif_transparent_index);
						imagecolortransparent($avatar_gif_image_resize, $avatar_gif_transparent_index);
					}

					imagecopyresampled($avatar_gif_image_resize,$avatar_gif_image_original,0,0,0,0,$avatar_gif_image_width,$avatar_gif_image_height,$avatar_gif_image_size[0],$avatar_gif_image_size[1]);

					unlink("$maj_image_directory/avatar.gif");

					imagegif($avatar_gif_image_resize,"$maj_image_directory/avatar.gif",100);

					imagedestroy($avatar_gif_image_resize);
					imagedestroy($avatar_gif_image_original);
				}
			}
			echo "<img src=\"$maj_image_directory/avatar.gif\" border=\"0\" width=\"$avatar_gif_image_width\" height=\"$avatar_gif_image_height\">";
		}

		if (file_exists("$maj_image_directory/avatar.jpg")) {

			$avatar_jpg_image_size = getimagesize("$maj_image_directory/avatar.jpg");
			$avatar_jpg_image_width = $avatar_jpg_image_size[0];
			$avatar_jpg_image_height = $avatar_jpg_image_size[1];
			
			if ($avatar_jpg_image_width > $max_img_width) {   

				$sizefactor = (double) ($max_img_width / $avatar_jpg_image_width) ;
				$avatar_jpg_image_width = (int) ($avatar_jpg_image_width * $sizefactor);
				$avatar_jpg_image_height = (int) ($avatar_jpg_image_height * $sizefactor); 

				if (file_exists("$maj_data_directory/avatar-resize-jpg.txt")) {

					$avatar_jpg_image_resize = imagecreatetruecolor($avatar_jpg_image_width,$avatar_jpg_image_height);
					$avatar_jpg_image_original = imagecreatefromjpeg("$maj_image_directory/avatar.jpg");

					imagecopyresampled($avatar_jpg_image_resize,$avatar_jpg_image_original,0,0,0,0,$avatar_jpg_image_width,$avatar_jpg_image_height,$avatar_jpg_image_size[0],$avatar_jpg_image_size[1]);

					unlink("$maj_image_directory/avatar.jpg");

					imagejpeg($avatar_jpg_image_resize,"$maj_image_directory/avatar.jpg",100);

					imagedestroy($avatar_jpg_image_resize);
					imagedestroy($avatar_jpg_image_original);
				}
			}
			echo "<img src=\"$maj_image_directory/avatar.jpg\" border=\"0\" width=\"$avatar_jpg_image_width\" height=\"$avatar_jpg_image_height\">";
		}

		if (file_exists("$maj_image_directory/avatar.png")) {

			$avatar_png_image_size = getimagesize("$maj_image_directory/avatar.png");
			$avatar_png_image_width = $avatar_png_image_size[0];
			$avatar_png_image_height = $avatar_png_image_size[1];
			
			if ($avatar_png_image_width > $max_img_width) {   

				$sizefactor = (double) ($max_img_width / $avatar_png_image_width) ;
				$avatar_png_image_width = (int) ($avatar_png_image_width * $sizefactor);
				$avatar_png_image_height = (int) ($avatar_png_image_height * $sizefactor); 

				if (file_exists("$maj_data_directory/avatar-resize-png.txt")) {

					$avatar_png_image_resize = imagecreatetruecolor($avatar_png_image_width,$avatar_png_image_height);

					imagealphablending($avatar_png_image_resize, false);
					imagesavealpha($avatar_png_image_resize, true);

					$avatar_png_image_original = imagecreatefrompng("$maj_image_directory/avatar.png");

					imagecopyresampled($avatar_png_image_resize,$avatar_png_image_original,0,0,0,0,$avatar_png_image_width,$avatar_png_image_height,$avatar_png_image_size[0],$avatar_png_image_size[1]);

					unlink("$maj_image_directory/avatar.png");

					imagepng($avatar_png_image_resize,"$maj_image_directory/avatar.png",100);

					imagedestroy($avatar_png_image_resize);
					imagedestroy($avatar_png_image_original);
				}
			}
			echo "<img src=\"$maj_image_directory/avatar.png\" border=\"0\" width=\"$avatar_png_image_width\" height=\"$avatar_png_image_height\">";
		}
		echo "<br>";
	}
	elseif (file_exists("$maj_image_directory/members/$author_username/avatar.jpg") or file_exists("$maj_image_directory/members/$author_username/avatar.gif") or file_exists("$maj_image_directory/members/$author_username/avatar.png")) {

		if (file_exists("$maj_image_directory/members/$author_username/avatar.gif")) {

			$avatar_gif_image_size = getimagesize("$maj_image_directory/members/$author_username/avatar.gif");
			$avatar_gif_image_width = $avatar_gif_image_size[0];
			$avatar_gif_image_height = $avatar_gif_image_size[1];

			if ($avatar_gif_image_width > $max_img_width) {   

				$sizefactor = (double) ($max_img_width / $avatar_gif_image_width) ;
				$avatar_gif_image_width = (int) ($avatar_gif_image_width * $sizefactor);
				$avatar_gif_image_height = (int) ($avatar_gif_image_height * $sizefactor); 

				if (file_exists("$maj_data_directory/avatar-resize-gif.txt")) {

					$avatar_gif_image_resize = imagecreatetruecolor($avatar_gif_image_width,$avatar_gif_image_height);

					imagealphablending($avatar_gif_image_resize, false);
					imagesavealpha($avatar_gif_image_resize, true);

					$avatar_gif_image_original = imagecreatefromgif("$maj_image_directory/members/$author_username/avatar.gif");
					$avatar_gif_transparent_index = imagecolortransparent($avatar_gif_image_original);

					if ($avatar_gif_transparent_index >= 0) {

						$avatar_gif_transparent_color = imagecolorsforindex($avatar_gif_image_original, $avatar_gif_transparent_index);
						$avatar_gif_transparent_index = imagecolorallocate($avatar_gif_image_resize, $avatar_gif_transparent_color['red'], $avatar_gif_transparent_color['green'], $avatar_gif_transparent_color['blue']);

						imagefill($avatar_gif_image_resize, 0, 0, $avatar_gif_transparent_index);
						imagecolortransparent($avatar_gif_image_resize, $avatar_gif_transparent_index);
					}

					imagecopyresampled($avatar_gif_image_resize,$avatar_gif_image_original,0,0,0,0,$avatar_gif_image_width,$avatar_gif_image_height,$avatar_gif_image_size[0],$avatar_gif_image_size[1]);

					unlink("$maj_image_directory/members/$author_username/avatar.gif");

					imagegif($avatar_gif_image_resize,"$maj_image_directory/members/$author_username/avatar.gif",100);

					imagedestroy($avatar_gif_image_resize);
					imagedestroy($avatar_gif_image_original);
				}
			}
			echo "<img src=\"$maj_image_directory/members/$author_username/avatar.gif\" border=\"0\" width=\"$avatar_gif_image_width\" height=\"$avatar_gif_image_height\">";
		}

		if (file_exists("$maj_image_directory/members/$author_username/avatar.jpg")) {

			$avatar_jpg_image_size = getimagesize("$maj_image_directory/members/$author_username/avatar.jpg");
			$avatar_jpg_image_width = $avatar_jpg_image_size[0];
			$avatar_jpg_image_height = $avatar_jpg_image_size[1];
			
			if ($avatar_jpg_image_width > $max_img_width) {   

				$sizefactor = (double) ($max_img_width / $avatar_jpg_image_width) ;
				$avatar_jpg_image_width = (int) ($avatar_jpg_image_width * $sizefactor);
				$avatar_jpg_image_height = (int) ($avatar_jpg_image_height * $sizefactor); 

				if (file_exists("$maj_data_directory/avatar-resize-jpg.txt")) {

					$avatar_jpg_image_resize = imagecreatetruecolor($avatar_jpg_image_width,$avatar_jpg_image_height);
					$avatar_jpg_image_original = imagecreatefromjpeg("$maj_image_directory/members/$author_username/avatar.jpg");

					imagecopyresampled($avatar_jpg_image_resize,$avatar_jpg_image_original,0,0,0,0,$avatar_jpg_image_width,$avatar_jpg_image_height,$avatar_jpg_image_size[0],$avatar_jpg_image_size[1]);

					unlink("$maj_image_directory/members/$author_username/avatar.jpg");

					imagejpeg($avatar_jpg_image_resize,"$maj_image_directory/members/$author_username/avatar.jpg",100);

					imagedestroy($avatar_jpg_image_resize);
					imagedestroy($avatar_jpg_image_original);
				}
			}
			echo "<img src=\"$maj_image_directory/members/$author_username/avatar.jpg\" border=\"0\" width=\"$avatar_jpg_image_width\" height=\"$avatar_jpg_image_height\">";
		}

		if (file_exists("$maj_image_directory/members/$author_username/avatar.png")) {

			$avatar_png_image_size = getimagesize("$maj_image_directory/members/$author_username/avatar.png");
			$avatar_png_image_width = $avatar_png_image_size[0];
			$avatar_png_image_height = $avatar_png_image_size[1];
			
			if ($avatar_png_image_width > $max_img_width) {   
				$sizefactor = (double) ($max_img_width / $avatar_png_image_width) ;
				$avatar_png_image_width = (int) ($avatar_png_image_width * $sizefactor);
				$avatar_png_image_height = (int) ($avatar_png_image_height * $sizefactor); 

				if (file_exists("$maj_data_directory/avatar-resize-png.txt")) {

					$avatar_png_image_resize = imagecreatetruecolor($avatar_png_image_width,$avatar_png_image_height);

					imagealphablending($avatar_png_image_resize, false);
					imagesavealpha($avatar_png_image_resize, true);

					$avatar_png_image_original = imagecreatefrompng("$maj_image_directory/members/$author_username/avatar.png");

					imagecopyresampled($avatar_png_image_resize,$avatar_png_image_original,0,0,0,0,$avatar_png_image_width,$avatar_png_image_height,$avatar_png_image_size[0],$avatar_png_image_size[1]);

					unlink("$maj_image_directory/members/$author_username/avatar.png");

					imagepng($avatar_png_image_resize,"$maj_image_directory/members/$author_username/avatar.png",100);

					imagedestroy($avatar_png_image_resize);
					imagedestroy($avatar_png_image_original);
				}
			}
			echo "<img src=\"$maj_image_directory/members/$author_username/avatar.png\" border=\"0\" width=\"$avatar_png_image_width\" height=\"$avatar_png_image_height\">";
		}
		echo "<br>";
	}
	
	if ($show_username != 0) {
		echo "<b>$author_username</b></a><br>";
	}
	
	if ($show_rank != 0) {

		if (($maj_admin_username == $author_username) and file_exists("$maj_data_directory/rank.txt")) {
			echo "administrator<br>";
		}
		elseif (file_exists("$maj_data_directory/members/active/$author_username/rank.txt") and file_exists("$maj_data_directory/rank.txt")) {
			$rank = file_get_contents("$maj_data_directory/members/active/$author_username/rank.txt");
			echo "$rank<br>";
		}
		elseif (!file_exists("$maj_data_directory/members/active/$author_username/rank.txt") and file_exists("$maj_data_directory/rank.txt")) {
			echo "member<br>";
		}
	}
}

function maj_download_file($file_name,$file_dir,$count_dir) {

	$file_size = filesize("$file_dir/$file_name");

	header("Cache-Control: ");
	header("Pragma: ");
	header("Content-Type: application/octet-stream");
	header("Content-Disposition: attachment; filename=$file_name");
	header("Content-Length: $file_size");

	$fp_file = fopen("$file_dir/$file_name","rb");

	while (!feof($fp_file)) {
		$file_buffer = fread($fp_file,4096);
		echo $file_buffer;
		$file_sent += strlen($file_buffer);
		flush();
	}

	fclose($fp_file);

	if (($file_sent == $file_size) and isset($count_dir)) {

		if (!file_exists($count_dir)) {
			mkdir($count_dir,0700,true);
		}

		if (file_exists("$count_dir/{$file_name}.txt")) {
			$file_downloads = file_get_contents("$count_dir/{$file_name}.txt");
		}
		else {
			$file_downloads = "0";
		}

		$file_downloads = $file_downloads + 1;

		$fp_downloads = fopen("$count_dir/{$file_name}.txt","w");
		fwrite($fp_downloads,$file_downloads);
		fclose($fp_downloads);
	}
}

?>
